#include "v3.h"
#include <math.h>

V3::V3(float x, float y, float z) {

  xyz[0] = x;
  xyz[1] = y;
  xyz[2] = z;

}

V3 V3::operator+(V3 op1) {

  V3 ret;
  ret.xyz[0] = xyz[0] + op1.xyz[0];
  ret.xyz[1] = xyz[1] + op1.xyz[1];
  ret.xyz[2] = xyz[2] + op1.xyz[2];

  return ret;

}

V3 V3::operator-(V3 op1) {

  V3 ret;
  ret.xyz[0] = xyz[0] - op1.xyz[0];
  ret.xyz[1] = xyz[1] - op1.xyz[1];
  ret.xyz[2] = xyz[2] - op1.xyz[2];

  return ret;

}

float V3::operator*(V3 op1) {

  float ret;
  ret = xyz[0]*op1.xyz[0]+xyz[1]*op1.xyz[1]+xyz[2]*op1.xyz[2];
  return ret;

}

V3 V3::operator^(V3 op1) {

  V3 ret;
  ret.xyz[0] = xyz[1]*op1.xyz[2]-xyz[2]*op1.xyz[1];
  ret.xyz[1] = xyz[2]*op1.xyz[0]-xyz[0]*op1.xyz[2];
  ret.xyz[2] = xyz[0]*op1.xyz[1]-xyz[1]*op1.xyz[0];

  return ret;

}

float& V3::operator[](int i) {

  return xyz[i];

}

ostream& operator<<(ostream &ostr, V3 v) {

  ostr << v[0] << " " << v[1] << " " << v[2] << " ";
  return ostr;

}

istream& operator>>(istream &istr, V3 &v) {

  istr >> v[0] >> v[1] >> v[2];
  return istr;

}

float V3::Length() {

  float l2 = (*this)*(*this);
  return sqrtf(l2);

}

V3 V3::operator*(float scf) {

  V3 ret = *this;
  ret.xyz[0] *= scf;
  ret.xyz[1] *= scf;
  ret.xyz[2] *= scf;
  return ret;
}
